/*Note: Input should be of the following format:
All edges starting from least value node should be entered first in the ascending order of it's neighbour following which should be the next lowest value node and so on.
Similar edge weight entry ordering should be followed.
Eg: For a complete triangular graph
Input file:
3
6
0 1
0 2
1 0
1 2
2 0
2 1
1	->corresponds to edge from node 0 to node 1
3	->corresponds to edge from node 0 to node 2
1	->corresponds to edge from node 1 to node 0
2	->corresponds to edge from node 1 to node 2
3	->corresponds to edge from node 2 to node 0
2	->corresponds to edge from node 2 to node 1
*/

#include "gmedian.h"

int main(int argc, char* argv[])
{
	FILE *fr,*fw;
	node_t med =0;
	int32_t* len; // length of each edge
	int from,to,numNodes,numEdges,wt;
	fr=fopen(argv[1],"r");	// input file is 1st argument
	fw=fopen(argv[2],"w");	// output file is 2nd argument
	gm_graph G;	//create empty graph
	fscanf(fr,"%d",&numNodes);
	fscanf(fr,"%d",&numEdges);	
	for(int i=0;i<numNodes;i++)	G.add_node();	//Add nodes 0 to numNodes-1
	for(int i=0;i<numEdges;i++)	//Add corresponding edges
	{
		fscanf(fr,"%d %d",&from,&to);
		G.add_edge(from,to);
	}
	len = new int[G.num_edges()];
	for(edge_t i = 0; i < G.num_edges(); i++)	//Add corresponding edges
	{
		fscanf(fr,"%d",&len[i]);
	}
	gmedian(G, len, med);
	fprintf(fw,"Median : %d\n",med);
	fclose(fr);
	fclose(fw);
	return 0;
}
