#include "topological_sort.h"
#include<time.h>

int main(int argc, char* argv[])
{
	FILE *fr,*fw;
	clock_t str,end,tot;
	int from,to,numNodes,numEdges;
	fr=fopen(argv[1],"r");	// input file is 1st argument
	fw=fopen(argv[2],"w");	// output file is 2nd argument
	gm_graph G;	//create empty graph
	fscanf(fr,"%d",&numNodes);
	fscanf(fr,"%d",&numEdges);	
	for(int i=0;i<numNodes;i++)	G.add_node();	//Add nodes 0 to numNodes-1
	for(int i=0;i<numEdges;i++)	//Add corresponding edges
	{
		fscanf(fr,"%d %d",&from,&to);
		G.add_edge(from,to);
	}
	gm_node_order out(G.num_nodes());
	str = clock();
	if(topological_sort(G, out))
	{
    	gm_node_order::seq_iter I = out.prepare_seq_iteration();
    	while (I.has_next()) 
    	{
        	node_t n = I.get_next();
        	fprintf(fw,"%d ", n);
    	}
	}
	else	
	{
		fprintf(fw,"Not DAG\n");
		gm_node_order::seq_iter I = out.prepare_seq_iteration();
    	/*while (I.has_next()) 
    	{
        	node_t n = I.get_next();
        	printf("%d ", n);
    	}*/
    }
	end = clock();
	tot = ((double)(end - str)) / CLOCKS_PER_SEC;
	printf("Total time taken by CPU: %f\n", tot  );
    fclose(fr);
    fclose(fw);
	return 0;
}
